diff --git a/elf/Makefile b/elf/Makefile
index 692a65b061..94ebcab1fa 100644
--- a/elf/Makefile
+++ b/elf/Makefile
@@ -412,6 +412,8 @@ tests += \
   tst-nodelete-opened \
   tst-noload \
   tst-null-argv \
+  tst-p_alignmod1-edit \
+  tst-p_align1 \
   tst-relsort1 \
   tst-ro-dynamic \
   tst-rtld-run-static \
@@ -728,6 +730,7 @@ modules-names = \
   tst-nodelete-dlclose-plugin \
   tst-nodelete-opened-lib \
   tst-null-argv-lib \
+  tst-p_alignmod-base \
   tst-relsort1mod1 \
   tst-relsort1mod2 \
   tst-ro-dynamic-mod \
@@ -2578,3 +2581,16 @@ CFLAGS-tst-dl_find_object-mod6.c += -funwind-tables
 CFLAGS-tst-dl_find_object-mod7.c += -funwind-tables
 CFLAGS-tst-dl_find_object-mod8.c += -funwind-tables
 CFLAGS-tst-dl_find_object-mod9.c += -funwind-tables
+
+$(objpfx)tst-p_alignmod-base.so: $(libsupport)
+
+$(objpfx)tst-p_align1: $(objpfx)tst-p_alignmod1.so
+
+# Make a copy of tst-p_alignmod-base.so and lower p_align of the first
+# PT_LOAD segment.
+$(objpfx)tst-p_alignmod1.so: $(objpfx)tst-p_alignmod1-edit \
+			     $(objpfx)tst-p_alignmod-base.so
+	rm -f $@
+	cp $(objpfx)tst-p_alignmod-base.so $@
+	$(test-wrapper-env) $(run-program-env) $(rtld-prefix) \
+	  $(objpfx)tst-p_alignmod1-edit $@
diff --git a/elf/tst-elf-edit.h b/elf/tst-elf-edit.h
new file mode 100644
index 0000000000..b764e78933
--- /dev/null
+++ b/elf/tst-elf-edit.h
@@ -0,0 +1,126 @@
+/* Update p_align of the first PT_LOAD segment.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <stdio.h>
+#include <stdbool.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <link.h>
+#include <error.h>
+#include <errno.h>
+#include <sys/stat.h>
+#include <sys/mman.h>
+
+const char *file_name;
+
+static size_t update_p_align (size_t);
+
+int
+main (int argc, char ** argv)
+{
+  if (argc != 2)
+    {
+      printf ("Usage: %s: file\n", argv[0]);
+      return 0;
+    }
+
+  file_name = argv[1];
+  struct stat statbuf;
+  int errno_saved;
+
+  if (stat (file_name, &statbuf) < 0)
+    error (1, errno, "%s: not exist", file_name);
+
+  ElfW(Ehdr) *ehdr;
+
+  if (statbuf.st_size < sizeof (*ehdr))
+    error (1, 0, "%s: too small", file_name);
+
+  int fd = open (file_name, O_RDWR);
+  if (fd < 0)
+    error (1, errno, "%s: can't open", file_name);
+
+  /* Map in the whole file.  */
+  void *base = mmap (NULL, statbuf.st_size, PROT_READ | PROT_WRITE,
+		     MAP_SHARED, fd, 0);
+  if (base == MAP_FAILED)
+    {
+      errno_saved = errno;
+      close (fd);
+      error (1, errno_saved, "%s: failed to map", file_name);
+    }
+
+  ehdr = (ElfW(Ehdr) *) base;
+  if (ehdr->e_ident[EI_MAG0] != ELFMAG0
+      || ehdr->e_ident[EI_MAG1] != ELFMAG1
+      || ehdr->e_ident[EI_MAG2] != ELFMAG2
+      || ehdr->e_ident[EI_MAG3] != ELFMAG3)
+    {
+      close (fd);
+      error (1, 0, "%s: bad ELF header", file_name);
+    }
+
+  if (ehdr->e_type != ET_DYN)
+    {
+      close (fd);
+      error (1, 0, "%s: not shared library", file_name);
+    }
+
+  bool unsupported_class = true;
+  switch (ehdr->e_ident[EI_CLASS])
+    {
+    default:
+      break;
+
+    case ELFCLASS32:
+      unsupported_class = __ELF_NATIVE_CLASS != 32;
+      break;
+
+    case ELFCLASS64:
+      unsupported_class = __ELF_NATIVE_CLASS != 64;
+      break;
+    }
+
+  if (unsupported_class)
+    {
+      close (fd);
+      error (1, 0, "%s: unsupported ELF class: %d",
+	     file_name, ehdr->e_ident[EI_CLASS]);
+    }
+
+  size_t phdr_size = sizeof (ElfW(Phdr)) * ehdr->e_phentsize;
+  if (statbuf.st_size < (ehdr->e_phoff + phdr_size))
+    {
+      close (fd);
+      error (1, 0, "%s: too small", file_name);
+    }
+
+  ElfW(Phdr) *phdr = (ElfW(Phdr) *) (base + ehdr->e_phoff);
+  for (int i = 0; i < ehdr->e_phnum; i++, phdr++)
+    if (phdr->p_type == PT_LOAD)
+      {
+	/* Update p_align of the first PT_LOAD segment.  */
+	phdr->p_align = update_p_align (phdr->p_align);
+	break;
+      }
+
+  munmap (base, statbuf.st_size);
+  close (fd);
+
+  return 0;
+}
diff --git a/elf/tst-p_align.h b/elf/tst-p_align.h
new file mode 100644
index 0000000000..cef92330fb
--- /dev/null
+++ b/elf/tst-p_align.h
@@ -0,0 +1,20 @@
+/* Prototypes to check different alignments of PT_LOAD segments in
+   a shared library.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+extern int do_load_test (void);
diff --git a/elf/tst-p_align1.c b/elf/tst-p_align1.c
new file mode 100644
index 0000000000..961c7fbbf1
--- /dev/null
+++ b/elf/tst-p_align1.c
@@ -0,0 +1,27 @@
+/* Check different alignments of PT_LOAD segments in a shared library.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include "tst-p_align.h"
+
+static int
+do_test (void)
+{
+  return do_load_test ();
+}
+
+#include <support/test-driver.c>
diff --git a/elf/tst-p_alignmod-base.c b/elf/tst-p_alignmod-base.c
new file mode 100644
index 0000000000..0fc1b75523
--- /dev/null
+++ b/elf/tst-p_alignmod-base.c
@@ -0,0 +1,41 @@
+/* Check alignment of PT_LOAD segment in a shared library.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <stdio.h>
+#include <stdbool.h>
+#include <stdint.h>
+#include <support/check.h>
+#include <tst-file-align.h>
+#include "tst-p_align.h"
+
+int foo __attribute__ ((aligned (ALIGN))) = 1;
+
+bool
+__attribute__ ((weak, noclone, noinline))
+is_aligned_p (void *p, int align)
+{
+  return (((uintptr_t) p) & (align - 1)) == 0;
+}
+
+int
+do_load_test (void)
+{
+  printf ("foo: %p\n", &foo);
+  TEST_VERIFY (is_aligned_p (&foo, ALIGN));
+  return 0;
+}
diff --git a/elf/tst-p_alignmod1-edit.c b/elf/tst-p_alignmod1-edit.c
new file mode 100644
index 0000000000..cdb453e696
--- /dev/null
+++ b/elf/tst-p_alignmod1-edit.c
@@ -0,0 +1,34 @@
+/* Reduce p_align of the first PT_LOAD segment by half.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include "tst-elf-edit.h"
+
+/* Reduce p_align by half.  */
+
+static size_t
+update_p_align (size_t p_align)
+{
+  size_t pagesize = sysconf (_SC_PAGESIZE);
+  size_t new_p_align = p_align >> 1;
+
+  if (new_p_align >= pagesize)
+    error (1, 0, "%s: new p_align (0x%zx) >= page size (0x%zx)",
+	   file_name, new_p_align, pagesize);
+
+  return new_p_align;
+}