diff --git a/elf/Makefile b/elf/Makefile
index c63abab44b..ad1c0ea7b6 100644
--- a/elf/Makefile
+++ b/elf/Makefile
@@ -416,6 +416,7 @@ tests += \
   tst-p_alignmod2-edit \
   tst-p_align1 \
   tst-p_align2 \
+  tst-p_align3 \
   tst-relsort1 \
   tst-ro-dynamic \
   tst-rtld-run-static \
@@ -733,6 +734,7 @@ modules-names = \
   tst-nodelete-opened-lib \
   tst-null-argv-lib \
   tst-p_alignmod-base \
+  tst-p_alignmod3 \
   tst-relsort1mod1 \
   tst-relsort1mod2 \
   tst-ro-dynamic-mod \
@@ -2608,3 +2610,10 @@ $(objpfx)tst-p_alignmod2.so: $(objpfx)tst-p_alignmod2-edit \
 	cp $(objpfx)tst-p_alignmod-base.so $@
 	$(test-wrapper-env) $(run-program-env) $(rtld-prefix) \
 	  $(objpfx)tst-p_alignmod2-edit $@
+
+LDFLAGS-tst-p_alignmod3.so += -Wl,-z,max-page-size=0x100,-z,common-page-size=0x100
+
+$(objpfx)tst-p_align3: $(objpfx)tst-p_alignmod3.so
+$(objpfx)tst-p_align3.out: tst-p_align3.sh $(objpfx)tst-p_align3
+	$(SHELL) $< $(common-objpfx) '$(test-program-prefix)'; \
+	$(evaluate-test)
diff --git a/elf/tst-p_align3.c b/elf/tst-p_align3.c
new file mode 100644
index 0000000000..8be9f311bd
--- /dev/null
+++ b/elf/tst-p_align3.c
@@ -0,0 +1,27 @@
+/* Check invalid p_align of PT_LOAD segments in a shared library.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include "tst-p_align.h"
+
+static int
+do_test (void)
+{
+  return do_load_test ();
+}
+
+#include <support/test-driver.c>
diff --git a/elf/tst-p_align3.sh b/elf/tst-p_align3.sh
new file mode 100755
index 0000000000..688c4b34cc
--- /dev/null
+++ b/elf/tst-p_align3.sh
@@ -0,0 +1,27 @@
+#!/bin/sh
+# Check invalid p_align of PT_LOAD segments in a shared library.
+# Copyright (C) 2022 Free Software Foundation, Inc.
+# This file is part of the GNU C Library.
+
+# The GNU C Library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2.1 of the License, or (at your option) any later version.
+
+# The GNU C Library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Lesser General Public License for more details.
+
+# You should have received a copy of the GNU Lesser General Public
+# License along with the GNU C Library; if not, see
+# <https://www.gnu.org/licenses/>.
+
+common_objpfx=$1; shift
+test_program_prefix=$1; shift
+
+${test_program_prefix} \
+  ${common_objpfx}elf/tst-p_align3 \
+    2> ${common_objpfx}elf/tst-p_align3.out
+test $? -ne 127 && exit 1
+grep "ELF load command address/offset not page-aligned" ${common_objpfx}elf/tst-p_align3.out
diff --git a/elf/tst-p_alignmod3.c b/elf/tst-p_alignmod3.c
new file mode 100644
index 0000000000..c15de3d6f2
--- /dev/null
+++ b/elf/tst-p_alignmod3.c
@@ -0,0 +1,25 @@
+/* Check invalid p_align of PT_LOAD segment in a shared library.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include "tst-p_align.h"
+
+int
+do_load_test (void)
+{
+  return 0;
+}